package quimufu.colourful_portals.client.mixin;

import com.google.gson.JsonObject;
import net.minecraft.client.resource.metadata.AnimationResourceMetadata;
import net.minecraft.client.resource.metadata.AnimationResourceMetadataReader;
import net.minecraft.util.JsonHelper;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;
import quimufu.colourful_portals.client.rendering.AlphaInterpolationHolder;

@Mixin(AnimationResourceMetadataReader.class)
public class AnimationResourceMetadataReaderMixin {

    @Inject(at = @At("RETURN"), method = "fromJson(Lcom/google/gson/JsonObject;)Lnet/minecraft/client/resource/metadata/AnimationResourceMetadata;", cancellable = true)
    void extractInterpolateAlpha(JsonObject jsonObject, CallbackInfoReturnable<AnimationResourceMetadata> cir) {
        boolean interpolateAlpha = JsonHelper.getBoolean(jsonObject, "interpolateAlpha", false);
        AnimationResourceMetadata returnValue = cir.getReturnValue();
        ((AlphaInterpolationHolder)returnValue).colourful_portals$setInterpolateAlpha(interpolateAlpha);
        cir.setReturnValue(returnValue);
        cir.cancel();
    }
}
